unit AnaDigIo;
// Schnittstelle zu Analog-Digital-IO-Box AnaDigIO der Fa. Seng.
// Version 1.2  Delphi3/Delphi5
// Stand   8.11.2001
// Programmierung: Ing. Bro Wolfgang Maier
//                 Menzingerstr. 156
//                 80997 Mnchen
//                 ingwmaier@compuserve.de

interface

Type  BoxType = (BNC_BOX,BOX_NONE,BOX_5B,BOX_SMB);

Const
   {Multiplexerwerte, Single-Ended, BNC-Box}
   ADmux_SE_1_BNC  = $F0;
   ADmux_SE_2_BNC  = $F1;
   ADmux_SE_3_BNC  = $F2;
   ADmux_SE_4_BNC  = $F3;
   ADmux_SE_5_BNC  = $F4;
   ADmux_SE_6_BNC  = $F5;
   ADmux_SE_7_BNC  = $F6;
   ADmux_SE_8_BNC  = $F7;
   ADmux_SE_9_BNC  = $F8;
   ADmux_SE_10_BNC = $F9;
   ADmux_SE_11_BNC = $FA;
   ADmux_SE_12_BNC = $FB;
   ADmux_SE_13_BNC  = $0F;
   ADmux_SE_14_BNC  = $1F;
   ADmux_SE_15_BNC  = $2F;
   ADmux_SE_16_BNC  = $3F;
   ADmux_SE_17_BNC  = $4F;
   ADmux_SE_18_BNC  = $5F;
   ADmux_SE_19_BNC  = $6F;
   ADmux_SE_20_BNC  = $7F;
   ADmux_SE_21_BNC  = $8F;
   ADmux_SE_22_BNC =  $9F;
   ADmux_SE_23_BNC =  $AF;
   ADmux_SE_24_BNC =  $BF;

   {Multiplexerwerte, Single-Ended, NONE/5B/SMB-Box}
   ADmux_SE_1_5B  = $F0;
   ADmux_SE_2_5B  = $0F;
   ADmux_SE_3_5B  = $F1;
   ADmux_SE_4_5B  = $1F;
   ADmux_SE_5_5B  = $F2;
   ADmux_SE_6_5B  = $2F;
   ADmux_SE_7_5B  = $F3;
   ADmux_SE_8_5B  = $3F;
   ADmux_SE_9_5B  = $F4;
   ADmux_SE_10_5B = $4F;
   ADmux_SE_11_5B = $F5;
   ADmux_SE_12_5B = $5F;
   ADmux_SE_13_5B  = $F6;
   ADmux_SE_14_5B  = $6F;
   ADmux_SE_15_5B  = $F7;
   ADmux_SE_16_5B  = $7F;
   ADmux_SE_17_5B  = $F8;
   ADmux_SE_18_5B  = $8F;
   ADmux_SE_19_5B  = $F9;
   ADmux_SE_20_5B  = $9F;
   ADmux_SE_21_5B  = $FA;
   ADmux_SE_22_5B =  $AF;
   ADmux_SE_23_5B =  $FB;
   ADmux_SE_24_5B =  $BF;

   {Multiplexer Differenz-Messung, NONE/BNC/5B/SMB-Box}
   ADmux_DIFF_1_BNC  = $00;
   ADmux_DIFF_2_BNC  = $11;
   ADmux_DIFF_3_BNC  = $22;
   ADmux_DIFF_4_BNC  = $33;
   ADmux_DIFF_5_BNC  = $44;
   ADmux_DIFF_6_BNC  = $55;
   ADmux_DIFF_7_BNC  = $66;
   ADmux_DIFF_8_BNC  = $77;
   ADmux_DIFF_9_BNC  = $88;
   ADmux_DIFF_10_BNC = $99;
   ADmux_DIFF_11_BNC = $AA;
   ADmux_DIFF_12_BNC = $BB;

   { Konstante fr GetMUX }
   AD_Differential   = TRUE;
   AD_Singleended    = false;



{$IFNDEF VER130}
{ in Delphi 3 gibt es kein LongWord !!!}
Type
  LongWord=Longint;
{$ENDIF}

(* folgende Prozeduren und Funktionen werden nachfolgend deklariert :
=====================================================================
function  lcasetup(pszFileName: PChar):Longint;
function  U0(voltage:single):Word;
function  U1(voltage:single):Word;
function  GetUDC : single;
function  InitAnaDigIODevice(iBaseAdr: Longint):LongBool;
procedure DeInitAnaDigIO;
Function  IsAnaDigIOInitialized:LongBool;
Procedure SetDigitalPortP0 (value: Byte);
Function  GetDigitalPortP1 : Byte;
Procedure BcUni1SetDigitalPortDir (Dir1_8,Dir9_12,Dir13_16,Dir17_24 :Byte);
Procedure BcUni1SetDigitalPort (uPort:LongWord;value:Byte);
Function  BcUni1GetDigitalPort(uPort: LongWord):Byte;
function  MUX(ChannelNr:Byte;Is_Differential:Boolean;Box:BoxType):Byte;
function  getADV(GAIN,MUX: Byte):Single;
function  getADVm(GAIN,MUX:Byte; Anzahl:LongWord):Single;
function  GetADRefVoltage:Single;
function  putDAVolt(Kanal:Byte;Volt: Single;Update:Byte):Longint;
procedure BcUni1putDAVolt(CHANNEL:Word;Volt:Single;Update:Word);
procedure SetIT1Volt(Volt:Single);
procedure StartPWM16(Channel, Mode:Byte);
function  GetPWM16(Channel,Mode :Byte):Single;
procedure StartFreqM(GateCh,CntCh :Byte; GateX128us:Word);
function  GetFreqM(CntCh :Byte; GateX128us:Word):Single;
function  GetCount16(Channel,Mode: Byte):Word;
function  GetCount32(Channel,Mode:Byte):LongWord;
function  FindMaxTesRate(Start: Word):LongInt;
function  getADTes(ChList:PChList; ADbuf:PADBuf; Anzahl, TuS:Word;
                  TrigCh:LongInt; TrigPre,TrigLevel:Word;
                  TrigSlope:Byte; TrigNotStop:Longword; TrigAdr:PAdBuf):Word;
function  getADTesDat(ChList: PChList;ADbuf:PADBuf; fChData: PChData; Anzahl,TuS:Word;
                    TrigCh :LongInt;TrigPre:Word;fTrigLevel:Single;
                    TrigSlope:Byte;TrigNotStop:LongWord;TrigAdr :PADBuf):Word;
function  enableDLLmessages_HWaccInit( pfn: PFKTMESSAGE ):LongBool;
function  enableDLLmessages_HWaccInitVb:LongBool;
function  GetAnaDigIODllDir( AnaDigIODllDir:PChar; iBufLen:Longint ):LongBool;
==============================================================================
*)

Type  PChList  = ^Word;
      PAdBuf   = ^Word;
      PChData  = ^Single;
      PFKTMESSAGE = function:PChar;

function lcasetup(pszFileName: PChar):Longint;
         stdcall; external 'AnaDigIO.DLL'  name 'lcasetup';
// LCA an Port CL PIO0 programmieren
// PIO0 Mode 0, Port A,B-Mode bleibt unbeinflut
// Portausgnge bei Gerten mit 82c55 werden auf low gesetzt, Port CU ist Eingang
// Parameter: LCA Konfigurationsdateiname
// return value:  0 = ok
//                1 = LCA-ERROR, NOT ABLE TO RESET DEVICE
//                2 = LCA-ERROR, CONFIG-FILE NOT FOUND
//                3 = LCA-ERROR, CONFIGURATION FAILED, DONE-PIN NOT HIGH

function Load_lcasetup(FileName: String):Longint;
//  idtentisch mit lcasetup, jedoch mit Pascal-String

function  U0(voltage:single):Word;
          stdcall; external 'AnaDigIO.DLL' name 'U0';
// einstellen des Spannungspegels U0, Angabe in Volt
// Parameter: Spannung U0 in Volt
// Return-Value: D/A-Wert


function  U1(voltage:single):Word;
          stdcall; external 'AnaDigIO.DLL' name 'U1';
// einstellen des Spannungspegels U1, Angabe in Volt
// Parameter: Spannung U1 in Volt
// Return-Value: D/A-Wert


function GetUDC : single;
         stdcall; external 'AnaDigIO.DLL' name 'GetUDC';
// mit Gerteversorgungsspannung UDC+
// Return-Value: UDC+ in Volt


function InitAnaDigIODevice(BaseAdr: Word):Boolean;
// initialisiert 004LAxxx parallel port Interface und Gesamtgert
// fr Gerte mit PLD und Gerte mit LCA Interface
// Testet ob Gert ansprechbar
// Parameter:	0 --> Autosearch
//				378h, 3BCh, 278h --> Schnittstellenadresse
// return value:	1 --> OK
//					0 --> Fehler


procedure  DeInitAnaDigIO;
// Gert und PC de-initialisieren
// Die Funktion de-initialisiert HWAccess, den Zugriff auf I/O Adressen
// mu vor dem Verlassen des Programmes aufgerufen werden
// Fehlerbehandlung, fatal errors, Programmabbruch


Function  IsAnaDigIOInitialized:Boolean;
// Gibt zurck ob ANADIGIO initialisiert ist
// Return Value:	1 --> initialisiert, TRUE
//					0 --> nicht initialisiert, FALSE

Procedure SetDigitalPortP0 (value: Byte);
   stdcall; external 'AnaDigIO.DLL' name 'SetDigitalPortP0';
// schreibt digtalen Ausgangsport P0
// Parameter: value

Function GetDigitalPortP1:Byte;
   stdcall; external 'AnaDigIO.DLL' name 'GetDigitalPortP1';
// liet digtalen Ausgangsport P0
// Return-Value: value


Procedure  BcUni1SetDigitalPortDir (Dir1_8,Dir9_12,Dir13_16,Dir17_24 :Byte);
   stdcall; external 'AnaDigIO.DLL' name 'BcUni1SetDigitalPortDir';
// Routine fr LCA auf Box Card Uni-1, das mit 012CA000.LCB konfiguriert ist
// Konfiguration ob Port DIO01..DIO24 Eingang oder Ausgang
// Parameter:	Dir1_8,		DIO01..DIO08,	0==Eingang, 1==Ausgang
//				Dir9_12,	DIO09..DIO12,	0==Eingang, 1==Ausgang
//				Dir13_16,	DIO13..DIO16,	0==Eingang, 1==Ausgang
//				Dir17_24,	DIO17..DIO24,	0==Eingang, 1==Ausgang


Procedure BcUni1SetDigitalPort (uPort:LongWord;value:Byte);
   stdcall; external 'AnaDigIO.DLL' name 'BcUni1SetDigitalPortDir';
// Routine fr LCA auf Box Card Uni-1, das mit 012CA000.LCB konfiguriert ist
// beschreibt digitalen Ausgangsport uPort mit value
// Parameter:	uPort --> 1, DIO01..DIO08
//				uPort --> 2, DIO09..DIO16
//				uPort --> 3, DIO17..DIO24
//				value 0..255


Function BcUni1GetDigitalPort(uPort: LongWord):Byte;
    stdcall; external 'AnaDigIO.DLL' name 'BcUni1GetDigitalPort';
// Routine fr LCA auf Box Card Uni-1, das mit 012CA000.LCB konfiguriert ist
// liet digitalen Eingangsport uPort
// Parameter:	uPort --> 1, DIO01..DIO08
//				uPort --> 2, DIO09..DIO16
//				uPort --> 3, DIO17..DIO24
// Return-Value:	value

function MUX(ChannelNr:Byte;Is_Differential:Boolean;Box:BoxType):Byte;
// ermittlet Multiplexerwert fr AD-Wandler  aus KanalNummer [1..12] bzw. [1..24]
// je nach dem ob Differential oder single-ended gemessen wird,
// und welcher Box-Typ verwendet wird
// Beispiel : X:=GetADV(1,Mux(3,AD_Differential,BNC_BOX));

function  getADV(GAIN,MUX: Byte):Single;
  stdcall; external 'AnaDigIO.DLL' name 'getADV';
// 12-Bit AD-Wandlung
// Parameter: GAIN -->	1	,PGA Verstrkungsfaktor 1
//						10	,PGA Verstrkungsfaktor 10
//						100 ,PGA Verstrkungsfaktor 100
//            MUX  --> Multiplexerwert Eingangskanal
// Return-Value:  -10.xxxxx...+10.xxxxx --> Eingangsspannung in Volt
//                 99.999  	--> positiv Overrange error
//                -99.999  	--> negativ Overrange error

function getADVm(GAIN,MUX:Byte; Anzahl:LongWord):Single;
  stdcall; external 'AnaDigIO.DLL' name 'getADVm';
// gemittelte 12-Bit AD-Wandlung
// Parameter: GAIN -->	1	,PGA Verstrkungsfaktor 1
//						10	,PGA Verstrkungsfaktor 10
//						100 ,PGA Verstrkungsfaktor 100
//            MUX  --> Multiplexerwert Eingangskanal
//            Anzahl --> Anzahl der Wandlungen
// Return-Value:  -10.xxxxx...+10.xxxxx --> Eingangsspannung in Volt
//                 99.999  	--> positiv Overrange error
//                -99.999  	--> negativ Overrange error


function GetADRefVoltage:Single;
  stdcall; external 'AnaDigIO.DLL' name 'GetADRefVoltage';
// Mit Gertereferenzspannung des Gertes
// Funktion nur zum Vergleich oder verifizieren verwenden, die Spannung mu mit einem externen
// mindestens 4,5 stelligen Voltmeter gemessen und der Wert ins EEPROM abgespeichert werden
// Return Value: Referenzspannung in Volt


function putDAVolt(Kanal:Byte;Volt: Single;Update:Byte):Longint;
  stdcall; external 'AnaDigIO.DLL' name 'putDAVolt';
// gibt Spannungswert Volt an DA-Wandler aus
// Parameter:	Kanal==1 --> AO1, Kanal==2 --> AO2
//				Spannung --> Volt
//				Update==0 --> nur Eingangsregister schreiben
//				Update==1 --> Eingangsregister und Ausgangsregister schreiben
// Return-Value:	0 -->   Ok
//					1 -->	Error, Out of Range


procedure BcUni1putDAVolt(CHANNEL:Word;Volt:Single;Update:Word);
  stdcall; external 'AnaDigIO.DLL' name 'BcUni1putDAVolt';
// Routine fr LCA auf Box Card Uni-1, das mit 012CA000.LCB konfiguriert ist
// Ausgeben der Ausgangsspannungen an DA-Wandler
// Parameter: CHANNEL 1..8 --> AO1..AO8
//            Volt -10.000...+10.000
//            Update==0 --> nur Eingangsregister schreiben
//            Update==1 --> Eingangsregister und Ausgangsregister schreiben
// Return Code:	0 --> Ok
//              1 --> Error, Out of Range



procedure SetIT1Volt(Volt:Single);
   stdcall; external 'AnaDigIO.DLL' name 'SetIT1Volt';
// Triggerschwelle Kanal IT1 einstellen, oberer Hysteresepunkt
// Parameter: Triggerschwelle IT1 in Volt, 1..30V


procedure StartPWM16(Channel, Mode:Byte);
    stdcall; external 'AnaDigIO.DLL' name 'StartPWM16';
// ermittelt 16-Bit Pulsbreite auf einem Counter-Channel
// Das Gert mu mit "007ca003.lcb" konfiguriert sein
// Parameter:	Channel:	0x0..0x2, Counter Channel
//							mit Konfiguration "007ca003.lcb" -> Channel immer 0x0
//				Mode:    Bit-Codiert
//				Bit 0,1: 0x2 --> __|---|__   Aktive-High Pulse-With
//								   ^-T-^
//
//				Bit 0,1: 0x1 --> --|___|--   Aktive-Low Pulse With
//                                 ^-T-^
//
//				Bit 0,1: 0x0 --> __|--|__|-- Periode-With
//								   ^--T--^
//
//				Bit 2,3: 0x0 --> 125ns Time-Base
//
//				Bit 2,3: 0x1 --> 4s Time-Base
//
//				Bit 2,3: 0x2 --> 128s Time-Base


function GetPWM16(Channel,Mode :Byte):Single;
  stdcall; external 'AnaDigIO.DLL' name 'GetPWM16';
// ermittelt 16-Bit Pulsbreite auf einem Counter-Channel
// Das Gert mu mit "007ca003.lcb" konfiguriert sein
// Parameter:	Channel:	0x0..0x2, Counter Channel
//							mit Konfiguration "007ca003.lcb" -> Channel immer 0x0
//				Mode:    Bit-Codiert
//				Bit 0,1: 0x2 --> __|---|__   Aktive-High Pulse-With
//								   ^-T-^
//
//				Bit 0,1: 0x1 --> --|___|--   Aktive-Low Pulse With
//								   ^-T-^
//
//				Bit 0,1: 0x0 --> __|--|__|-- Periode-With
//								   ^--T--^
//
//				Bit 2,3: 0x0 --> 125ns Time-Base
//
//				Bit 2,3: 0x1 --> 4s Time-Base
//
//				Bit 2,3: 0x2 --> 128s Time-Base
// Return Value: OK                  --> >=0, seconds
//               Waiting for trigger --> -1
//               PWM in progress     --> -2
//               Timer overflow      --> -3


procedure StartFreqM(GateCh,CntCh :Byte; GateX128us:Word)
   stdcall; external 'AnaDigIO.DLL' name 'StartFreqM';
// Startet Messung zur Ermittlung der Frequenz des Eingangssignals
// Das Gert mu mit "007ca003.lcb" konfiguriert sein
// Parameter:	GateCh:	0x0..0x2, Counter Channel Gate
//						mit Konfiguration "007ca004.lcb" -> GateCh immer 0x1
//				CntCh:	0x0..0x2, Counter Channel Count
//						mit Konfiguration "007ca004.lcb" -> CntCh immer 0x2
//				GateX128us: Gate-Time = GateX128us * 128s


function GetFreqM(CntCh :Byte; GateX128us:Word):Single;
   stdcall; external 'AnaDigIO.DLL' name 'GetFreqM';
// Prft ob Frequenzmessung abgeschlossen und gibt Messwert zurck
// Das Gert mu mit "007ca003.lcb" konfiguriert sein
// Parameter:	CntCh:	0x0..0x2, Counter Channel Count
//						mit Konfiguration "007ca004.lcb" -> CntCh immer 0x2
//				GateX128us: Gate-Time = GateX128us * 128s
// Return Value: >= 0  -->  Frequenz in Hertz
//                 -1  -->  FM in progress
//                 -2  -->  Counter overflow, Frequency/Gate-Time high
//                 -3  -->  Null Count, Frequency/Gate-Time low


function GetCount16(Channel,Mode: Byte):Word;
  stdcall; external 'AnaDigIO.DLL' name 'GetCount16';
// Ermittelt 16-Bit Zhlwert auf einem Counter-Channel.
// Das Gert mu mit "007ca004.lcb" konfiguriert sein
// Zhler wird im Mode 2 betrieben, MaxCount=0xFFFF,MinCount=1.
// Der 8254 ist im Mode 2 ein 16-Bit Rate Generator.
// Ein Initialisieren des Zhlers setzt das Eingangsregister auf 0xFFFF
// und erzeugt zwei Pulse am Takteingang des Zhlers. Im Ausgangsregister
// des Zhlers ist nun ebenfalls 0xFFFF auslesbar.
// Zhlfolge 8254: FFFFh,FFFEh,FFFDh,...,3h,2h,1h,FFFFh,FFFEh,FFFDh...
// Parameter:	Channel: 0x0..0x2, Counter Channel
//				Mode:	0x0 --> Zhler nur auslesen
//						0x1 --> Zhler als low-Word-Counter initialisieren dann auslesen
//						0x2 --> Zhler als high-Word-Counter initialisieren dann auslesen
// Return-Wert: 0h,1h,2h,...,FFFDh,FFFEh,0h,1h,2h,...


function GetCount32(Channel,Mode:Byte):LongWord;
  stdcall; external 'AnaDigIO.DLL' name 'GetCount32';
// Ermittelt 32-Bit Zhlwert auf zwei kaskadierten 16-Bit Counter-Channels
// Das Gert mu mit "007ca004.lcb" konfiguriert sein
// Parameter:	Channel:	0x0 --> 8254 Channel 0 low-word, 8254 Channel 1 high-word
//							0x1 --> 8254 Channel 1 low-word, 8254 Channel 2 high-word
// Mode:	0x0 --> Zhler nur auslesen
//			0x1 --> Zhler initialisieren dann auslesen
// Return-Wert: 0h,1h,...,FFFEh,FFFFh,10000h,10001h,...,FFFE0000h,0h,1h,...


function FindMaxTesRate(Start: Word):LongInt;
  stdcall; external 'AnaDigIO.DLL' name 'FindMaxTesRate';
// ANMERKUNG: Funktion unter WIN32 nur sehr eingeschrnkt verwendbar, da der Rechner unter WIN32
// whrend der Datenerfassung nicht in vollem Mae verfgbar, dies fhrt zum Verlust von Daten,
// der Rckgabewert der Funktion gibt hierber jedoch Auskunft
// Die Funktion erlaubt unter DOS unter Verwendung von disable() Erfassraten >=25s
// unter WIN32 ohne Verwendung von disable() sind nur sichere Erfassraten >3000s erreichbar
//
// ermittelt maximale TES Rate
// Parameter: Startwert in s
// Return Value:   > 0 --> kurzmglichste TES Abtastrate in s
//					 0 --> memory allocation error
//					-2 --> Anfangs TES Testabtstrate zu kurz


function getADTes(ChList:PChList; ADbuf:PADBuf; Anzahl, TuS:Word;
                  TrigCh:LongInt; TrigPre,TrigLevel:Word;
                  TrigSlope:Byte; TrigNotStop:Longword; TrigAdr:PAdBuf):Word;
  stdcall; external 'AnaDigIO.DLL' name 'GetADTes';


// ANMERKUNG: Funktion unter WIN32 nur sehr eingeschrnkt verwendbar, da der Rechner unter WIN32
// whrend der Datenerfassung nicht in vollem Mae verfgbar, dies fhrt zum Verlust von Daten,
// der Rckgabewert der Funktion gibt hierber jedoch Auskunft
// die Funktion erlaubt unter DOS unter Verwendung von disable() Erfassraten >=25s
// unter WIN32 ohne Verwendung von disable() sind nur sichere Erfassraten >3000s erreichbar
//
// 12-Bit AD-Wandlung, Time Equivalent Sampling mit Eingangskanalliste
// (Pre-)Triggerfunktion und Time-Out
// Die Daten werden in einem Ringspeicher abgelegt, Organisation 16x24K, die
// kleinste Adresse ist somit 0h die hchste 5FFFh. Der Speicherindex des
// ersten Datums nach dem Triggerzeitpunkt wird ber TrigAdr zurckgegeben
// Parameter:	ChList --> Zeiger auf CHList, Eingangskanalliste mit MUX und Gain
//				ADbuf --> Zeiger auf ADbuf
//				Anzahl --> Anzahl Wandlungen pro Kanal
//				TuS --> Abtastrate in s
//		 		TrigCh --> Indexadresse Triggerkanal im Feld ChList
//				TrigPre --> Anzahl der Wandlungen im Kanal vor Triggerzeitpunkt
//				TrigLevel --> Triggerschwelle in Digits
//				TrigSlope --> 0 fallende Flanke, 1 steigende Flanke,
//                      	  2 sofort kein Flanke, 3 nicht triggern
//			  	TrigNotStop --> TrigNotStop*TuS ist die Zeit bis zum Abbruch der
//                        		Routine, falls kein Trigger erkannt wird
//			  	TrigAdr --> Indexadresse des 1. Wertes des Triggerkanals nach
//                    		dem Triggerzeitpunkt im Feld ADbuf
// Return-Value:	0x0         --> Alle Abtastungen OK
//              	0x1..0xFFFD --> Anzahl lckenhafter Abtastungen
//				 	0xFFFE      --> NoTrigger TimeOut
//				 	0xFFFF      --> AD-TimeOut error


function getADTesDat(ChList: PChList;ADbuf:PADBuf; fChData: PChData; Anzahl,TuS:Word;
                    TrigCh :LongInt;TrigPre:Word;fTrigLevel:Single;
                    TrigSlope:Byte;TrigNotStop:LongWord;TrigAdr :PADBuf):Word;
    stdcall; external 'AnaDigIO.DLL' name 'GetADTesDat';
// ANMERKUNG: Funktion unter WIN32 nur sehr eingeschrnkt verwendbar, da der Rechner unter WIN32
// whrend der Datenerfassung nicht in vollem Mae verfgbar, dies fhrt zum Verlust von Daten,
// der Rckgabewert der Funktion gibt hierber jedoch Auskunft
// Die Funktion erlaubt unter DOS unter Verwendung von disable() Erfassraten >=25s
// unter WIN32 ohne Verwendung von disable() sind nur sichere Erfassraten >3000s erreichbar
//
// 12-Bit AD-Wandlung, Time Equivalent Sampling mit Eingangskanalliste
// (Pre-)Triggerfunktion und Time-Out
// Die Daten werden in einem Ringspeicher abgelegt, Organisation 24Kx16, die
// kleinste Adresse ist somit 0h die hchste 5FFFh. Der Speicherindex des
// ersten Datums nach dem Triggerzeitpunkt wird ber TrigAdr zurckgegeben
// Die erfassten Daten werden jeweils im Feld fChData mit Zeitbezug abgelegt,
// Zeiten in Sekunden, Spannungen in Volt skaliert, Feldtiefe max. 48Kxfloat
// Das Feld ist folgendermaen organisiert (ChList[0]=m):
// K1Zeit0,K1Zeit1,...K1Zeitn,K1Volt0,K1Volt1...K1Voltn,
// K2Zeit0,K2Zeit1,...K2Zeitn,K2Volt0,K2Volt1...K2Voltn,...
// ...,KmZeit0,KmZeit1,...KmZeitn,KmVolt0,KmVolt1...KmVoltn
// Parameter:	ChList -->	Zeiger auf CHList, Eingangskanalliste mit MUX und Gain
//				ADbuf -->	Zeiger auf ADbuf
//				fChData -->	Zeiger auf fChData, Zeiten in [s], Spannungen in [Volt]
//				Anzahl -->	Anzahl Wandlungen pro Kanal
//				TuS -->	Abtastrate in s
//		 	  	TrigCh -->	Indexadresse Triggerkanal im Feld ChList
//			  	TrigPre -->	Anzahl der Wandlungen im Kanal vor Triggerzeitpunkt
//			  	fTrigLevel -->	Triggerschwelle in Volt
//				TrigSlope -->	0 fallende Flanke
//								1 steigende Flanke
//								2 sofort kein Flanke
//								3 nicht triggern
//				TrigNotStop -->	TrigNotStop*TuS ist die Zeit bis zum Abbruch der
//								Routine, falls kein Trigger erkannt wird
//			  	TrigAdr -->	Indexadresse des 1. Wertes des Triggerkanals nach dem
//							Triggerzeitpunkt im Feld ADbuf
// Return-Value:	0x0         --> Alle Abtastungen OK
//               	0x1..0xFFFD --> Anzahl lckenhafter Abtastungen
//				 	0xFFFE      --> NoTrigger TimeOut
//				 	0xFFFF      --> AD-TimeOut error


function enableDLLmessages_HWaccInit( pfn: PFKTMESSAGE ):LongBool;
  stdcall; external 'AnaDigIO.DLL' name 'enableDLLmessages_HWaccInit';

function GetAnaDigIODllDir( AnaDigIODllDir:PChar; iBufLen:Longint ):LongBool;
  stdcall; external 'AnaDigIO.DLL' name 'GetAnaDigIODllDir';



implementation
Uses Dialogs, Windows;

Const InitDevice_Ausgefuehrt:Boolean=false;
Var   Handle: LongInt;

Function  __IsAnaDigIOInitialized:LongBool;
   stdcall; external 'AnaDigIO.DLL' name 'IsAnaDigIOInitialized';

procedure  __DeInitAnaDigIO;
     stdcall; external 'AnaDigIO.DLL' name 'DeInitAnaDigIO';

function __InitAnaDigIODevice(iBaseAdr: Longint):LongBool;
         stdcall; external 'AnaDigIO.DLL' name 'InitAnaDigIODevice';

Function  IsAnaDigIOInitialized:Boolean;
begin
  IsAnaDigIOInitialized:=InitDevice_Ausgefuehrt and __IsAnaDigIOInitialized;
end;

function Load_lcasetup(FileName: String):Longint;
{$IFOPT H-}
  {$H+}
Var Name:String;
  {$H-}
{$ENDIF}
begin
 {$IFOPT H-}
  Name:=Filename;
  Load_lcasetup:=lcasetup(PChar(name));
 {$ELSE}
  Load_lcasetup:=lcasetup(PChar(Filename));
 {$ENDIF}
end;

Function InitAnaDigIoDevice(BaseAdr:Word):Boolean;
Var OK:Boolean;
begin
  InitAnaDigIoDevice:=false;
  DeInitAnaDigIO;
  If Not enableDLLmessages_HWaccInit(nil) then
    begin
      MessageDlg('Der Hardware-Zugriffs-Treiber HWAccess.sys/vxd'#13+'konnte nicht geladen werden !', mtError,[mbOK],0);
    end
  else
   begin
     OK:=__InitAnaDigIODevice(BaseAdr);
     InitDevice_Ausgefuehrt:=True;
     If Not OK then
       MessageDlg('Gert wurde nicht gefunden.'#13+'Bitte fhren Sie AnaIni.exe aus', mtError,[mbOK],0);
     InitAnaDigIoDevice:=OK;
   end;
end;

function MUX(ChannelNr:Byte;Is_Differential:Boolean;Box:BoxType):Byte;
begin
  If Is_Differential then
    begin
      If (ChannelNr>12) or (ChannelNr<1) then
        ChannelNr:=1;
      MUX:=((ChannelNr-1) and $0F) or (((ChannelNr-1) and $0F) shl 4);
    end
  else
    begin
      If (ChannelNr>24) or (ChannelNr<1) then
          ChannelNr:=1;
      If Box=BNC_BOX then
       begin
         If ChannelNr<13 then
           // 1..12 -> 0..11
           MUX:=((ChannelNr-1) and $0F) or $F0
         else
           // 13..24 -> 0..11
           MUX:=(((ChannelNr-13) and $0F) shl 4) or $0F;
       end
      else
       begin
         If Odd(ChannelNr) then
           { ungerade 1,3,5...}
           MUX:=(((ChannelNr-1) shr 1) and  $0F) or $F0
         else
           {gerade 2,4,6.. }
           MUX:=((((ChannelNr-1) shr 1) and  $0F) shl 4) or $0F;
       end; {If Box.. }
    end;
end;


procedure  DeInitAnaDigIO;
begin
  If  InitDevice_Ausgefuehrt  then
     __DeInitAnaDigIO;
  InitDevice_Ausgefuehrt:=false;
end;

initialization
 InitDevice_Ausgefuehrt:=false;

finalization
  DeInitAnaDigIO;
  Handle:=GetModuleHandle('AnadigIo.DLL');
  If Handle<>0 then freeLibrary(Handle);
end.
