unit Setup;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, WStrTool, ExtCtrls, AnaDigIo, Buttons, FileCtrl;

Type
    SRateType  = (sek,min,hrs);
    Ini_Var = Packed Record
             Abtastrate        : Extended;
             DatenDir          : String[255];
             KDim:  Array[1..8] of String[5];
             KFact: Array[1..8] of extended;
             KoffSet: Array[1..8] of extended;
             KTara    : Array[1..8] of boolean;
             KKomma   : Array[1..8] of integer;
             Samplingrate : Integer;
             SamplingDim  : SRateType;
             TaraSRate    : Integer;
             TaraTime     : Extended;
             AvgSamples   : integer;
             AvgRate      : integer;
             SingleEnded  : Boolean;
             BoxenTyp     : integer;
           end; // of Record

Var   StartDir              : String;
      IniDirFileName        : String;
      Datei                 : TextFile;
      Ini                   : Ini_var;
      Ini_File              : File of ini_var;
      Tara_Laeuft           : Boolean;
      Messung_Laeuft        : Boolean;
      PrMessung_Laeuft      : Boolean;
      i, j                  : LongInt;
      WertBuffer            : Array[1..8] of extended;
      Differential          : boolean;
      BoxTyp                : BoxType;
      Wert                  : extended;
      SrateAvg              : Longint;
      SRateTotal            : extended; //Samplingrate auf Mess. pro Sek normiert
      SrateLoops            : Longint;  //Anzahl der Messdurchlufe 
      AktLoop               : LongInt;  //Aktueller Durchlauf bei der Messung
      AvgZeit               : extended;
      RohWert               : array[1..8] of extended;
      MessWert              : array[1..8] of extended;
      AvgLoops              : LongInt;
      DateiTextZeile        : String;
      DateiName             : String;
      StartZeit             : extended;
      ThreadError           : Boolean;
      MessNummer            : LongInt;
      MittelungLaeuft       : Boolean;

Const IniFileName = 'dehn_win.ini';

type
  TSetupForm = class(TForm)
    Button_SetupEnde: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label_Dim1: TLabel;
    Edit_Kdim1: TEdit;
    Edit_Kdim2: TEdit;
    Label_Dim2: TLabel;
    Edit_Kdim3: TEdit;
    Label_Dim3: TLabel;
    Edit_Kdim4: TEdit;
    Label_Dim4: TLabel;
    Edit_Kdim5: TEdit;
    Label_Dim5: TLabel;
    Edit_Kdim6: TEdit;
    Label_Dim6: TLabel;
    Edit_Kdim7: TEdit;
    Label_Dim7: TLabel;
    Label_Dim8: TLabel;
    Edit_Offset1: TEdit;
    Edit_Offset2: TEdit;
    Edit_Offset3: TEdit;
    Edit_Offset4: TEdit;
    Edit_Offset5: TEdit;
    Edit_Offset6: TEdit;
    Edit_Offset7: TEdit;
    Edit_Offset8: TEdit;
    Label1: TLabel;
    Label_Einheit: TLabel;
    Label_Offset: TLabel;
    Edit_Kdim8: TEdit;
    Label_Faktor: TLabel;
    Edit_Fakt1: TEdit;
    Edit_Fakt3: TEdit;
    Edit_Fakt4: TEdit;
    Edit_Fakt5: TEdit;
    Edit_Fakt6: TEdit;
    Edit_Fakt7: TEdit;
    Edit_Fakt8: TEdit;
    Edit_Fakt2: TEdit;
    CheckBox_Tara1: TCheckBox;
    CheckBox_Tara2: TCheckBox;
    CheckBox_Tara3: TCheckBox;
    CheckBox_Tara5: TCheckBox;
    CheckBox_Tara6: TCheckBox;
    CheckBox_Tara7: TCheckBox;
    CheckBox_Tara8: TCheckBox;
    CheckBox_Tara4: TCheckBox;
    Label_Tara: TLabel;
    TabSheet3: TTabSheet;
    RadioGroup1: TRadioGroup;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    Edit_Abtastrate: TEdit;
    Label_Abtastrate: TLabel;
    Edit_Mittelungen: TEdit;
    Label_Mittelungen: TLabel;
    Label_Mittelungsfrequenz: TLabel;
    Edit_Mittelungsfrequenz: TEdit;
    TabSheet4: TTabSheet;
    SelectBoxTyp: TRadioGroup;
    Image1: TImage;
    RadioGroup_SE_DI: TRadioGroup;
    RadioButton_SE: TRadioButton;
    RadioButton_DI: TRadioButton;
    Label_TaraMesszeit: TLabel;
    Label_TaraSRate: TLabel;
    Edit_TaraMesszeit: TEdit;
    Edit_TaraSRate: TEdit;
    Label_Srate: TLabel;
    SpeedButton1: TSpeedButton;
    Edit_DataPath: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    ComboBox5: TComboBox;
    ComboBox6: TComboBox;
    ComboBox7: TComboBox;
    ComboBox8: TComboBox;
    procedure Button_SetupEndeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Edit_DataPathChange(Sender: TObject);
    procedure Edit_Kdim1Change(Sender: TObject);
    procedure Edit_Kdim2Change(Sender: TObject);
    procedure Edit_Kdim3Change(Sender: TObject);
    procedure Edit_Kdim4Change(Sender: TObject);
    procedure Edit_Kdim5Change(Sender: TObject);
    procedure Edit_Kdim6Change(Sender: TObject);
    procedure Edit_Kdim7Change(Sender: TObject);
    procedure Edit_Kdim8Change(Sender: TObject);
    procedure Edit_Offset1Change(Sender: TObject);
    procedure Edit_Offset2Change(Sender: TObject);
    procedure Edit_Offset3Change(Sender: TObject);
    procedure Edit_Offset4Change(Sender: TObject);
    procedure Edit_Offset5Change(Sender: TObject);
    procedure Edit_Offset6Change(Sender: TObject);
    procedure Edit_Offset7Change(Sender: TObject);
    procedure Edit_Offset8Change(Sender: TObject);
    procedure Edit_Fakt1Change(Sender: TObject);
    procedure Edit_Fakt2Change(Sender: TObject);
    procedure Edit_Fakt3Change(Sender: TObject);
    procedure Edit_Fakt4Change(Sender: TObject);
    procedure Edit_Fakt5Change(Sender: TObject);
    procedure Edit_Fakt6Change(Sender: TObject);
    procedure Edit_Fakt7Change(Sender: TObject);
    procedure Edit_Fakt8Change(Sender: TObject);
    procedure CheckBox_Tara1Click(Sender: TObject);
    procedure CheckBox_Tara2Click(Sender: TObject);
    procedure CheckBox_Tara3Click(Sender: TObject);
    procedure CheckBox_Tara4Click(Sender: TObject);
    procedure CheckBox_Tara5Click(Sender: TObject);
    procedure CheckBox_Tara6Click(Sender: TObject);
    procedure CheckBox_Tara7Click(Sender: TObject);
    procedure CheckBox_Tara8Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure Edit_AbtastrateChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Edit_MittelungenChange(Sender: TObject);
    procedure Edit_MittelungsfrequenzChange(Sender: TObject);
    procedure SelectBoxTypClick(Sender: TObject);
    procedure RadioButton_SEClick(Sender: TObject);
    procedure RadioButton_DIClick(Sender: TObject);
    procedure Edit_TaraSRateChange(Sender: TObject);
    procedure Edit_TaraMesszeitChange(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure ComboBox4Change(Sender: TObject);
    procedure ComboBox5Change(Sender: TObject);
    procedure ComboBox6Change(Sender: TObject);
    procedure ComboBox7Change(Sender: TObject);
    procedure ComboBox8Change(Sender: TObject);

    private
    { Private-Deklarationen }
    public
    { Public-Deklarationen }

  end;

Procedure ini_schreiben;
Procedure ini_lesen;
Procedure ini_default;

Var       SetupForm             : TSetupForm;



implementation


{$R *.DFM}



Procedure Ini_Default;
Var i: integer;
Begin
   ini.Abtastrate:=10;
   ini.DatenDir:=Home_DirName('');
   ini.KDim[1]:='C';
   For i:=2 to 8 do ini.kdim[i]:='mm';
   For i:=1 to 8 do ini.kFact[i]:=1;
   For i:=1 to 8 do ini.koffset[i]:=0;
   For i:=1 to 8 do ini.KKomma[i]:=1;
   ini.ktara[1]:=False;
   For i:=2 to 8 do ini.ktara[i]:=true;
   ini.SamplingRate:=1;
   ini.SamplingDim:=min;
   ini.AvgRate:=100;
   ini.AvgSamples:=10;
   ini.TaraTime:=1;
   ini.TaraSRate:=100;
end;

Procedure Ini_Schreiben;
Begin
  AssignFile(Ini_file,IniDirFileName);
  ReWrite(Ini_File);
  Write(Ini_File,ini);
  CloseFile(Ini_File);
End;

Procedure Ini_Lesen;
Begin
  AssignFile(Ini_file,IniDirFileName);
  Reset(Ini_File);
  Read(Ini_File,ini);
  CloseFile(Ini_File);

end;



procedure TSetupForm.Button_SetupEndeClick(Sender: TObject);
begin
   Case ini.SamplingDim of
      sek : If ini.SamplingRate >10 then
               Begin
                 showMessage('die Abtastrate mu kleiner 10 Messungen pro Sekunde sein');
                 showMessage('die Abtastrate wird nun auf 10 gestellt');
                 ini.Samplingrate:=10;
               end;
      min : If ini.SamplingRate > 600 then
               Begin
                 showMessage('die Abtastrate mu kleiner 600 Messungen pro Minute sein');
                 showMessage('die Abtastrate wird nun auf 600 gestellt');
                 ini.Samplingrate:=600;
               end;
      hrs :  If ini.SamplingRate >36000 then
               Begin
                 showMessage('die Abtastrate mu kleiner 36000 Messungen pro Stunde sein');
                 showMessage('die Abtastrate wird nun auf 36000 gestellt');
                 ini.Samplingrate:=36000;
               end;
   end;  // of case
   if (ini.Samplingrate<1) then
      Begin
        showMessage('die Abtastrate mu grer Null sein');
        showMessage('die Abtastrate wird nun auf 1 gestellt');
        ini.Samplingrate:=1;
      end;
 if (ini.AvgSamples<1) then
      Begin
        showMessage('die Anzahl der Mittelungen mu mindestens 1 und nicht mehr als 100 sein');
        showMessage('die Mittelungsanzahl wird nun auf 1 gestellt');
        ini.AvgSamples:=1;
      end;
   if (ini.AvgSamples>100) then
      Begin
        showMessage('die Anzahl der Mittelungen mu mindestens 1 und nicht mehr als 100 sein');
        showMessage('die Mittelungsanzahl wird nun auf 100 gestellt');
        ini.AvgSamples:=100;
      end;
   if (ini.AvgRate<1) then
      Begin
        showMessage('die Mittelungsabtastrate mu mindestens 1Hz betragen');
        showMessage('die Mittelungsabtastrate wird nun auf 1Hz gestellt');
        ini.AvgRate:=1;
      end;
   if (ini.AvgRate>10) then
      Begin
        showMessage('die Mittelungsabtastrate darf nicht gre als 10Hz betragen');
        showMessage('die Mittelungsabtastrate wird nun auf 10 gestellt');
        ini.AvgRate:=10;
      end;
   case ini.SamplingDim of
      sek  : If ((ini.AvgSamples*(1/ini.AvgRate)) > (0.5/ini.Samplingrate)) then
              Begin
                 ShowMessage('Die Mittelungsdauer einer Messung ist grer als 0,5/Abtastrate');
                 ShowMessage('Abtastraten werden angepasst  -  Bitte nochmal kontrollieren');
                 ini.SamplingRate:=round(0.5*ini.AvgRate);
                 ini.AvgSamples:=1;
              end;
      min  :  If ((ini.AvgSamples*(1/ini.AvgRate)) > (30/ini.Samplingrate)) then
              Begin
                 ShowMessage('Die Mittelungsdauer einer Messung ist grer als 0,5/Abtastrate');
                 ShowMessage('Abtastraten werden zurckgesetzt  -  Bitte nochmal kontrollieren');
                 ini.SamplingRate:=1;
                 ini.AvgSamples:=1;
              end;
      hrs  :  If ((ini.AvgSamples*(1/ini.AvgRate)) > (1800/ini.Samplingrate)) then
              Begin
                 ShowMessage('Die Mittelungsdauer einer Messung ist grer als 0,5/Abtastrate');
                 ShowMessage('Abtastraten werden zurckgesetzt  -  Bitte nochmal kontrollieren');
                 ini.SamplingRate:=1;
                 ini.AvgSamples:=1;
              end;
   end; //of case
   if (ini.TaraSRate>10) then
      Begin
        showMessage('die Abtastrate fr die Tarierung als 10Hz sein');
        showMessage('die Abtastrate fr die Tarierung wird nun auf 10 gestellt');
        ini.TaraSrate:=10;
      end;
   if (ini.TaraSRate<2) then
      Begin
        showMessage('die Abtastrate fr die Tarierung mu mindestens 2Hz betragen');
        showMessage('die Abtastrate fr die Tarierung wird nun auf 2Hz gestellt');
        ini.TaraSrate:=2;
      end;
   if (ini.TaraTime>10) then
      Begin
        showMessage('Die Messzeit fr die Tariermessung darf nicht ber 10 Sekunden sein');
        showMessage('Die Messzeit fr die Tarierung wird nun auf 10 Sekunden gestellt');
        ini.TaraTime:=10;
      end;
   if (ini.TaraTime<0.1) then
      Begin
        showMessage('Die Messzeit fr die Tariermessung darf nicht kleiner als 0,1 Sekunden sein');
        showMessage('Die Messzeit fr die Tarierung wird nun auf 0,1 Sekunden gestellt');
        ini.TaraTime:=0.1;
      end;

   Ini_Schreiben;
end;

procedure TSetupForm.FormCreate(Sender: TObject);
begin
   If Fileexists(IniDirFileName) then
   Ini_Lesen else
   begin
     Ini_Default;
     Ini_Schreiben;
   end;
  SetupForm.Width:=PageControl1.Width+40;
  SetupForm.Height:=PageControl1.Height+100;

end;

procedure TSetupForm.Edit_DataPathChange(Sender: TObject);
begin
  ini.DatenDir:=Edit_DataPath.text;
end;

procedure TSetupForm.Edit_Kdim1Change(Sender: TObject);
begin
  ini.Kdim[1]:=Edit_Kdim1.text;
end;

procedure TSetupForm.Edit_Kdim2Change(Sender: TObject);
begin
   ini.Kdim[2]:=Edit_Kdim2.text;
end;

procedure TSetupForm.Edit_Kdim3Change(Sender: TObject);
begin
   ini.Kdim[3]:=Edit_Kdim3.text;
end;

procedure TSetupForm.Edit_Kdim4Change(Sender: TObject);
begin
  ini.Kdim[4]:=Edit_Kdim4.text;
end;

procedure TSetupForm.Edit_Kdim5Change(Sender: TObject);
begin
   ini.Kdim[5]:=Edit_Kdim5.text;
end;

procedure TSetupForm.Edit_Kdim6Change(Sender: TObject);
begin
   ini.Kdim[6]:=Edit_Kdim6.text;
end;

procedure TSetupForm.Edit_Kdim7Change(Sender: TObject);
begin
   ini.Kdim[7]:=Edit_Kdim7.text;
end;

procedure TSetupForm.Edit_Kdim8Change(Sender: TObject);
begin
   ini.Kdim[8]:=Edit_Kdim8.text;
end;

procedure TSetupForm.Edit_Offset1Change(Sender: TObject);
begin
   Try
      ini.KOffset[1]:=StrtoFloat(Edit_Offset1.Text);
   except
      ShowMessage('Es mu ein Zahlenwert eingegeben werden !');
   end;
end;

procedure TSetupForm.Edit_Offset2Change(Sender: TObject);
begin
   Try
      ini.KOffset[2]:=StrtoFloat(Edit_Offset2.Text);
   except
      ShowMessage('Es mu ein Zahlenwert eingegeben werden !');
   end;
end;

procedure TSetupForm.Edit_Offset3Change(Sender: TObject);
begin
   Try
      ini.KOffset[3]:=StrtoFloat(Edit_Offset3.Text);
   except
      ShowMessage('Es mu ein Zahlenwert eingegeben werden !');
   end;
end;

procedure TSetupForm.Edit_Offset4Change(Sender: TObject);
begin
   Try
      ini.KOffset[4]:=StrtoFloat(Edit_Offset4.Text);
   except
      ShowMessage('Es mu ein Zahlenwert eingegeben werden !');
   end;
end;

procedure TSetupForm.Edit_Offset5Change(Sender: TObject);
begin
   Try
      ini.KOffset[5]:=StrtoFloat(Edit_Offset5.Text);
   except
      ShowMessage('Es mu ein Zahlenwert eingegeben werden !');
   end;
end;

procedure TSetupForm.Edit_Offset6Change(Sender: TObject);
begin
   Try
      ini.KOffset[6]:=StrtoFloat(Edit_Offset6.Text);
   except
      ShowMessage('Es mu ein Zahlenwert eingegeben werden !');
   end;
end;

procedure TSetupForm.Edit_Offset7Change(Sender: TObject);
begin
   Try
      ini.KOffset[7]:=StrtoFloat(Edit_Offset7.Text);
   except
      ShowMessage('Es mu ein Zahlenwert eingegeben werden !');
   end;
end;

procedure TSetupForm.Edit_Offset8Change(Sender: TObject);
begin
   Try
      ini.KOffset[8]:=StrtoFloat(Edit_Offset8.Text);
   except
      ShowMessage('Es mu ein Zahlenwert eingegeben werden !');
   end;
end;

procedure TSetupForm.Edit_Fakt1Change(Sender: TObject);
begin
   Try
      ini.KFact[1]:=StrtoFloat(Edit_Fakt1.Text);
   except
      ShowMessage('Es mu ein Zahlenwert eingegeben werden !');
   end;
end;

procedure TSetupForm.Edit_Fakt2Change(Sender: TObject);
begin
   Try
      ini.KFact[2]:=StrtoFloat(Edit_Fakt2.Text);
   except
      ShowMessage('Es mu ein Zahlenwert eingegeben werden !');
   end;
end;

procedure TSetupForm.Edit_Fakt3Change(Sender: TObject);
begin
   Try
      ini.KFact[3]:=StrtoFloat(Edit_Fakt3.Text);
   except
      ShowMessage('Es mu ein Zahlenwert eingegeben werden !');
   end;
end;

procedure TSetupForm.Edit_Fakt4Change(Sender: TObject);
begin
   Try
      ini.KFact[4]:=StrtoFloat(Edit_Fakt4.Text);
   except
      ShowMessage('Es mu ein Zahlenwert eingegeben werden !');
   end;
end;

procedure TSetupForm.Edit_Fakt5Change(Sender: TObject);
begin
   Try
      ini.KFact[5]:=StrtoFloat(Edit_Fakt5.Text);
   except
      ShowMessage('Es mu ein Zahlenwert eingegeben werden !');
   end;
end;

procedure TSetupForm.Edit_Fakt6Change(Sender: TObject);
begin
   Try
      ini.KFact[6]:=StrtoFloat(Edit_Fakt6.Text);
   except
      ShowMessage('Es mu ein Zahlenwert eingegeben werden !');
   end;
end;

procedure TSetupForm.Edit_Fakt7Change(Sender: TObject);
begin
   Try
      ini.KFact[7]:=StrtoFloat(Edit_Fakt7.Text);
   except
      ShowMessage('Es mu ein Zahlenwert eingegeben werden !');
   end;
end;

procedure TSetupForm.Edit_Fakt8Change(Sender: TObject);
begin
   Try
      ini.KFact[8]:=StrtoFloat(Edit_Fakt8.Text);
   except
      ShowMessage('Es mu ein Zahlenwert eingegeben werden !');
   end;
end;

procedure TSetupForm.CheckBox_Tara1Click(Sender: TObject);
begin
   ini.ktara[1]:=CheckBox_Tara1.Checked;
end;

procedure TSetupForm.CheckBox_Tara2Click(Sender: TObject);
begin
   ini.ktara[2]:=CheckBox_Tara2.Checked;
end;

procedure TSetupForm.CheckBox_Tara3Click(Sender: TObject);
begin
   ini.ktara[3]:=CheckBox_Tara3.Checked;
end;

procedure TSetupForm.CheckBox_Tara4Click(Sender: TObject);
begin
   ini.ktara[4]:=CheckBox_Tara4.Checked;
end;

procedure TSetupForm.CheckBox_Tara5Click(Sender: TObject);
begin
   ini.ktara[5]:=CheckBox_Tara5.Checked;
end;

procedure TSetupForm.CheckBox_Tara6Click(Sender: TObject);
begin
   ini.ktara[6]:=CheckBox_Tara6.Checked;
end;

procedure TSetupForm.CheckBox_Tara7Click(Sender: TObject);
begin
   ini.ktara[7]:=CheckBox_Tara7.Checked;
end;

procedure TSetupForm.CheckBox_Tara8Click(Sender: TObject);
begin
   ini.ktara[8]:=CheckBox_Tara8.Checked;
end;

procedure TSetupForm.RadioButton2Click(Sender: TObject);
begin
   ini.SamplingDim:=min;
end;

procedure TSetupForm.RadioButton1Click(Sender: TObject);
begin
   ini.SamplingDim:=sek;
end;

procedure TSetupForm.RadioButton3Click(Sender: TObject);
begin
   ini.SamplingDim:=hrs;
end;

procedure TSetupForm.Edit_AbtastrateChange(Sender: TObject);
begin
   Try
     ini.Samplingrate:=StrToInt(Edit_Abtastrate.Text);
   except
     ShowMessage('Es mu ein ganzzahliger Wert < 10 Messungen pro Sekunde eingegeben werden');
   end;
end;


procedure TSetupForm.FormShow(Sender: TObject);
begin

   With Ini do  //TabSheet1 auffrischen
     begin
       Edit_DataPath.text:=DatenDir;
     end;
  With Ini do   //TabSheet2 auffrischen
     begin
       Edit_Kdim1.text:=Kdim[1];
       Edit_Kdim2.text:=Kdim[2];
       Edit_Kdim3.text:=Kdim[3];
       Edit_Kdim4.text:=Kdim[4];
       Edit_Kdim5.text:=Kdim[5];
       Edit_Kdim6.text:=Kdim[6];
       Edit_Kdim7.text:=Kdim[7];
       Edit_Kdim8.text:=Kdim[8];
       Edit_Offset1.Text:=FloatToStr(KOffset[1]);
       Edit_Offset2.Text:=FloatToStr(KOffset[2]);
       Edit_Offset3.Text:=FloatToStr(KOffset[3]);
       Edit_Offset4.Text:=FloatToStr(KOffset[4]);
       Edit_Offset5.Text:=FloatToStr(KOffset[5]);
       Edit_Offset6.Text:=FloatToStr(KOffset[6]);
       Edit_Offset7.Text:=FloatToStr(KOffset[7]);
       Edit_Offset8.Text:=FloatToStr(KOffset[8]);
       Edit_Fakt1.Text:=FloatToStr(KFact[1]);
       Edit_Fakt2.Text:=FloatToStr(KFact[2]);
       Edit_Fakt3.Text:=FloatToStr(KFact[3]);
       Edit_Fakt4.Text:=FloatToStr(KFact[4]);
       Edit_Fakt5.Text:=FloatToStr(KFact[5]);
       Edit_Fakt6.Text:=FloatToStr(KFact[6]);
       Edit_Fakt7.Text:=FloatToStr(KFact[7]);
       Edit_Fakt8.Text:=FloatToStr(KFact[8]);
       ComboBox1.Text:=IntToStr(KKomma[1]);
       ComboBox2.Text:=IntToStr(KKomma[2]);
       ComboBox3.Text:=IntToStr(KKomma[3]);
       ComboBox4.Text:=IntToStr(KKomma[4]);
       ComboBox5.Text:=IntToStr(KKomma[5]);
       ComboBox6.Text:=IntToStr(KKomma[6]);
       ComboBox7.Text:=IntToStr(KKomma[7]);
       ComboBox8.Text:=IntToStr(KKomma[8]);
       CheckBox_Tara1.Checked:=KTara[1];
       CheckBox_Tara2.Checked:=KTara[2];
       CheckBox_Tara3.Checked:=KTara[3];
       CheckBox_Tara4.Checked:=KTara[4];
       CheckBox_Tara5.Checked:=KTara[5];
       CheckBox_Tara6.Checked:=KTara[6];
       CheckBox_Tara7.Checked:=KTara[7];
       CheckBox_Tara8.Checked:=KTara[8];
   end;
With ini do  //TabSheet3 auffrischen
Begin
  Edit_Abtastrate.Text:=IntToSTr(SamplingRate);
  Case SamplingDim of
     Sek :  RadioButton1.checked:=true;
     min :  RadioButton2.checked:=true;
     hrs :  RadioButton3.checked:=true;
  end; //of case
  Edit_Mittelungen.Text:=IntToStr(AvgSamples);
  Edit_Mittelungsfrequenz.Text:=IntToStr(AvgRate);
  Edit_TaraMesszeit.Text:=FloatToStr(TaraTime);
  Edit_TaraSRate.Text:=IntToStr(TaraSrate);
end;
With Ini do //TabSheet4 auffrischen
Begin
  if ini.SingleEnded = true then
       RadioButton_SE.checked:=True
       else RadioButton_DI.checked:=True;

  SelectBoxTyp.ItemIndex:=ini.Boxentyp;
end;
end;

procedure TSetupForm.Edit_MittelungenChange(Sender: TObject);
begin
   Try
     ini.AvgSamples:=StrToInt(Edit_Mittelungen.Text);
   except
     ShowMessage('Es mu ein ganzzahliger Wert <= 100 eingegeben werden');
   end;
end;

procedure TSetupForm.Edit_MittelungsfrequenzChange(Sender: TObject);
begin
   Try
     ini.AvgRate:=StrToInt(Edit_Mittelungsfrequenz.Text);
   except
     ShowMessage('Es mu ein ganzzahliger Wert <= 1000 eingegeben werden');
   end;
end;

procedure TSetupForm.SelectBoxTypClick(Sender: TObject);
begin
   ini.Boxentyp:=SelectBoxTyp.ItemIndex;
end;

procedure TSetupForm.RadioButton_SEClick(Sender: TObject);
begin
   ini.SingleEnded:=True;
end;

procedure TSetupForm.RadioButton_DIClick(Sender: TObject);
begin
  ini.SingleEnded:=false;
end;

procedure TSetupForm.Edit_TaraSRateChange(Sender: TObject);
begin
   Try
     ini.TaraSrate:=StrToInt(Edit_TaraSRate.Text);
   except
     ShowMessage('Es mu ein ganzzahliger Wert < 1000 eingegeben werden');
   end;
end;

procedure TSetupForm.Edit_TaraMesszeitChange(Sender: TObject);
begin
   Try
      ini.TaraTime:=StrToFloat(Edit_TaraMesszeit.Text);
     except
       ShowMessage('Es mu ein nummerischer Wert eingegeben werden');
     end;
end;

procedure TSetupForm.SpeedButton1Click(Sender: TObject);
Var Pfad : String;
begin
 Pfad:=Edit_DataPath.Text;
  If  SelectDirectory(Pfad, [sdAllowCreate, sdPerformCreate, sdPrompt],0) then
    begin
       Edit_DataPath.text:=Pfad;
       ini.DatenDir:=Pfad;
    end;

end;

procedure TSetupForm.ComboBox1Change(Sender: TObject);
begin
   ini.kkomma[1]:=strToInt(ComboBox1.Text);
end;

procedure TSetupForm.ComboBox2Change(Sender: TObject);
begin
   ini.kkomma[2]:=strToInt(ComboBox2.Text);
end;

procedure TSetupForm.ComboBox3Change(Sender: TObject);
begin
   ini.kkomma[3]:=strToInt(ComboBox3.Text);
end;

procedure TSetupForm.ComboBox4Change(Sender: TObject);
begin
   ini.kkomma[4]:=strToInt(ComboBox4.Text);
end;

procedure TSetupForm.ComboBox5Change(Sender: TObject);
begin
   ini.kkomma[5]:=strToInt(ComboBox5.Text);
end;

procedure TSetupForm.ComboBox6Change(Sender: TObject);
begin
   ini.kkomma[6]:=strToInt(ComboBox6.Text);
end;

procedure TSetupForm.ComboBox7Change(Sender: TObject);
begin
   ini.kkomma[7]:=strToInt(ComboBox7.Text);
end;

procedure TSetupForm.ComboBox8Change(Sender: TObject);
begin
   ini.kkomma[8]:=strToInt(ComboBox8.Text);
end;

end.
